<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Admin\Pengajuan;
use Exception;
use GuzzleHttp\Client;
use Storage;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class SakuController extends Controller
{

    public function index() {
        // $penelaah = DB::table('tr_penelaah')->orderBy('id_pengajuan')->get();

        $penelaah = DB::table('tr_penelaah')
            ->select('tr_penelaah.*', 'tr_pengajuan.id_pengajuan as id_pengajuan_epk', 'tr_pengajuan.no_sk', 'tr_pengajuan.judul', 'tr_pengajuan.peneliti', 'tr_pengajuan.tahun', 'tr_pengajuan.klasifikasi', 'tr_pengajuan.file_ec', 'ms_kategori.nama_kategori')
            ->join('tr_pengajuan', 'tr_pengajuan.id', 'tr_penelaah.id_pengajuan')
            ->join('ms_kategori', 'ms_kategori.id', 'tr_pengajuan.id_kategori')
            ->orderBy('id_pengajuan')
            ->get();

        if($penelaah){
            foreach ($penelaah as $key => $pen) {
                $nosurat = explode('/', $pen->no_sk);
                $noagenda = $nosurat[0];
                $tahun = $nosurat[3];
                $arrPenelaah[$key] = [
                    'id' => $pen->id,
                    'id_pengajuan' => $pen->id_pengajuan,
                    'nik' => $pen->nik,
                    'nama' => $pen->nama,
                    'nip' => $pen->nip,
                    'id_pengajuan_epk' => $pen->id_pengajuan_epk,
                    'judul' => $pen->judul,
                    'peneliti' => $pen->peneliti,
                    'nama_kategori' => $pen->nama_kategori,
                    'klasifikasi' => $pen->klasifikasi,
                    'file_ec' => $pen->file_ec,
                    'tahun' => $pen->tahun,
                    'nosurat' => $noagenda,
                    'tahunsk' => $tahun,
                    'namafile' => $this->getFileName($tahun, $noagenda)
                ];
            }
        }

        $data = [
            'penelaah' => $arrPenelaah,
        ];

        return view('saku.index', $data);
    }

    public function getFileName($tahun, $nosurat){
        $client = new Client();

        $response = $client->request('GET', 'https://e-office.unesa.ac.id/api/show-surat-keluar/'.$tahun.'/'.$nosurat);
        $data = json_decode($response->getBody(), true);

        if (is_null($data)) {
            $namafile = '';
        }
        if (empty($data)) {
            $namafile = '';
        }
        else{
            $namafile = $data['namafile'];
        }

        return $namafile;

    }
}
